from vector import *
import timer

def fixAngle(val):   
   val = val % (2*pi)
   if val > pi:
      return val - 2*pi
   elif val < -pi:
      return val + 2*pi
   else:
      return val

def getTargetAngle(pos, weaponVel, target):
   assert isinstance(pos, Vector)
   assert isinstance(weaponVel, (int, float))
   a = getAngle(pos, target.pos)
   t = sin(pi-a+target.vel.dir)*target.vel.mag/weaponVel
   if abs(t) < 1: # this will return a 'nan' (python bug, i think)
      return fixAngle(a - asin(t))
   else:
      return a

def closest(pos, targets):
   assert isinstance(pos, Vector)
   assert isinstance(targets, list), 'targets should be list, got %s' % targets
   if targets:
      return min((dist(pos, t.pos), t) for t in targets)[1]
   else:
      return None
   

class AI:
   targetAngle = 0
   def avoid(self, target):
      self.orientation = fixAngle(self.orientation)
      dAngle = fixAngle(self.orientation - getTargetAngle(self.pos, self.vel.mag, target))
      if dAngle > 0:
         self.turn(self.turnSpeed * timer.percTicked)
      else:
         self.turn(-self.turnSpeed * timer.percTicked)
   
   def seek(self, target):
      self.orientation = fixAngle(self.orientation)
      self.targetAngle = getTargetAngle(self.pos, self.weaponVel, target)
      dAngle = fixAngle(self.orientation - self.targetAngle)
      if dAngle > 0:
         self.turn(-self.turnSpeed * timer.percTicked)
      else:
         self.turn(self.turnSpeed * timer.percTicked)

# vim: set et sts=3 sw=3:
