from util import *

#particleTexture = loadTexture("blob_1")

class EffectManager:
   particleSize = .7
   def __init__(self):
      self.objects = []
      self.particles = []
      
   def drawParticles(self):  
       s = self.particleSize
       # This does it with arrays (lighting doesn't work)
#      glPushClientAttrib(GL_CLIENT_VERTEX_ARRAY_BIT)
#      glNormal(0, 0, 1)
#      glEnableClientState(GL_VERTEX_ARRAY)
#      glEnableClientState(GL_COLOR_ARRAY)
#      glEnableClientState(GL_NORMAL_ARRAY)
#      vertp = []
#      colorp = []
#      for dot in self.particles:
#         x, y, z = dot.pos
#         c = tuple(dot.color)
#         vertp.append((x+s, y+s, z))
#         vertp.append((x+s, y-s, z))
#         vertp.append((x-s, y-s, z))
#         vertp.append((x-s, y+s, z))
#         colorp.extend([c, c, c, c])
#      l = range(len(vertp))
#      glVertexPointerd(vertp)
#      glColorPointerd(colorp)
#      glNormalPointerd([(0,0,1) for x in l])
#      glDrawElementsui(GL_QUADS, l)
#      glDisableClientState(GL_VERTEX_ARRAY)
#      glDisableClientState(GL_COLOR_ARRAY)
#      glDisableClientState(GL_NORMAL_ARRAY)
#      glPopClientAttrib()
      
      # this does it with textures. looks cooler with no textures
#   glBindTexture(GL_TEXTURE_2D, particleTexture)
#   glEnable(GL_TEXTURE_2D)
#   glNormal(0, 0, 1)
#   glBegin(GL_QUADS)
#   for p in dots:
#      r, g, b = p.color
#      glColor(r, g, b, p.alpha)
#      x, y, z = p.pos
#      glTexCoord2f(1.0, 1.0); glVertex(x+s, y+s, z)
#      glTexCoord2f(0.0, 1.0); glVertex(x-s, y+s, z)
#      glTexCoord2f(0.0, 0.0); glVertex(x-s, y-s, z)
#      glTexCoord2f(1.0, 0.0); glVertex(x+s, y-s, z)
#   glEnd()
#   glDisable(GL_TEXTURE_2D)

       glNormal(0, 0, 1)
       glBegin(GL_QUADS)
       for p in self.particles:
          r, g, b = p.color
          glColor(r, g, b, p.alpha)
          x, y, z = p.pos
          glVertex(x+s, y+s, z)
          glVertex(x-s, y+s, z)
          glVertex(x-s, y-s, z)
          glVertex(x+s, y-s, z)
       glEnd()
       glDisable(GL_TEXTURE_2D)
      
      
   def draw(self):
      self.particles.sort(key=lambda x: x.pos.z)
      for o in self.objects:
         o.draw()
      self.drawParticles()
   
   def update(self):
      for o in self.objects:
         o.move()
         o.update()
         if not o.onScreen() or not o.alive:
            self.objects.remove(o)
      for p in self.particles:
         p.move()
         p.update()
         if not p.onScreen() or not p.alive:
            self.particles.remove(p)
         
   
   def explodeModel(self, object):
      zxorientation = 0
      preEffects = []
      for e in object.preEffects:
         if e == tilt:
            preEffects.append(e)
            zxorientation = object.zxorientation
      wireModel = False
      for e in object.postEffects:
         if isinstance(e, WireModel):
            wireModel = True
      color = object.color
      pos = object.pos
      vel = object.vel
      orientation = object.orientation
      velor = orientation - pi/2
      life = object.explodeSize
      model = object.model
      for face in model.faces:
         vertices = {}
         normals = {}
         for v, n in face:
            vertices[v] = (model.vertices[v])
            normals[n] = (model.normals[n])
         evel = vAvg([Vector(v) for v in vertices.values()])
         evel.dir += velor
         evel.mag = uniform(.25, .75)
         evel += vel/2.0
         shard = ExpiringParticle(pos.copy, evel.copy, color, life)
         shard.model = wavefront.Object(vertices, normals, [face])
         shard.orientation = orientation
         shard.zxorientation = zxorientation
         shard.preEffects = preEffects + [Spinner(uniform(-1, 1), randomAxis())]
         if wireModel:
            shard.postEffects = [WireModel(shard.model)]
         self.objects.append(shard)
   
   def explodeParticles(self, size, pos, vel, rad, color):
      self.particles += [ExpiringParticle(pos.jitter(rad/2.0), vel.randDir(), color, size) for x in range(int(size/30.0))]
   
   def thrust(self, pos, vel, color, life):
      self.particles.append(ExpiringParticle(pos, vel.jitter(.2), color, 
                                                   uniform(.75, 1.25)*life))
   
   def shrinkModel(self, object):
      shrink = ShrinkParticle(object.pos, object.vel, object.color, object.explodeSize)
      shrink.model = object.model      
      shrink.orientation = object.orientation
      shrink.alpha = object.alpha
      for e in object.preEffects:
         if e == tilt:
            shrink.preEffects.append(e)
            shrink.zxorientation = object.zxorientation
         elif isinstance(e, Spinner):
            shrink.preEffects.append(e)
      for e in object.postEffects:
         if isinstance(e, WireModel):
            shrink.postEffects.append(e)
      self.objects.append(shrink)


class Thruster:
   def __init__(self, offset=lambda s: s.radius):
      self.offset = offset
   def __call__(self, obj):
      if timer.fiveTurnTimer.ready():
            explosion.thrust(obj.pos + Vectorp(-self.offset(obj), obj.orientation),
                                      Vector(0,0,0), obj.color, obj.explodeSize)

def playerThruster(obj):
  if obj.vel:
     o = obj.orientation
     vel = Vectorp(-.5, o)
     pos = obj.pos
     side = cos(obj.zxorientation)
     r = Vectorp(4, o-2.71)
     z = r.x*sin(obj.zxorientation)
     r.x *= side
     r.z -= z
     l = Vectorp(4, o+2.71)
     l.x *= side
     l.z += z
     explosion.thrust(pos+r, vel, ~obj.color, obj.explodeSize)
     explosion.thrust(pos+l, vel, ~obj.color, obj.explodeSize)

def playerAccelThruster(obj):
  if obj.thrusting:
     o = obj.orientation
     vel = Vectorp(-.5, o) + obj.vel
     pos = obj.pos
     side = cos(obj.zxorientation)
     r = Vectorp(4, o-2.71)
     z = r.x*sin(obj.zxorientation)
     r.x *= side
     r.z -= z
     l = Vectorp(4, o+2.71)
     l.x *= side
     l.z += z
     explosion.thrust(pos+r, vel, ~obj.color, obj.explodeSize)
     explosion.thrust(pos+l, vel, ~obj.color, obj.explodeSize)


class ExpiringParticle(Object):
   def __init__(self, pos, vel, color, life):
      assert isinstance(vel, Vector)
      assert isinstance(pos, Vector)
      assert isinstance(color, Color)
      self.vel = vel
      self.pos = pos
      self.color = color
      self.lifeTime = timer.Timer(life)
   def update(self):
      if self.lifeTime.ready():
         self.alive = False
      self.alpha = 1.0-self.lifeTime.percReady()
   def drawModel(self):
      for face in self.model.faces:
         glBegin(GL_POLYGON)
         for v, n in face:
            glNormal3fv(self.model.normals[n])
            glVertex3fv(self.model.vertices[v])
         glEnd()


def shrink(obj):
  glScale(obj.size, obj.size, obj.size)

class ShrinkParticle(ExpiringParticle):
   size = 1.0
   def __init__(self, *args):
      ExpiringParticle.__init__(self, *args)
      self.preEffects = [shrink]
      self.postEffects = []
   def update(self):
      if self.lifeTime.ready():
         self.alive = False
      self.size = 1.0-self.lifeTime.percReady()

      
class StarGenerator:
   maxStars = 25
   color = Color([1,1,.8])
   alpha = .1
   z = lambda s: uniform(-20, -40)
   speed = -0.4
  
   def __init__(self):
       self.stars = []
   
   def update(self):
      x, y, z = display.screenSize
      d = self.drawSize = x/2
      self.stars += [Vector([uniform(-x, x), y+d, self.z()]) for i in range(self.maxStars-len(self.stars))]
      if timer.fiveTurnTimer.ready():
         self.stars.sort(key=lambda x: x.z)
      for s in self.stars:
        s.y += self.speed*timer.percTicked
        if s.y < -y-d:
           self.stars.remove(s)
   
   def populate(self):
      x, y, z = display.screenSize
      d = self.drawSize = x/2
      self.stars += [Vector([uniform(-x, x), uniform(-y-d, y+d), self.z()]) for i in range(self.maxStars)]
   
   def draw(self):
      s = self.drawSize/2.0
      glNormal(0, 0, 1)
      r, g, b = self.color
      glColor(r, g, b, self.alpha)
      glBegin(GL_QUADS)
      for x,y,z in self.stars:
         glVertex(x+s, y+s, z)
         glVertex(x-s, y+s, z)
         glVertex(x-s, y-s, z)
         glVertex(x+s, y-s, z)
      glEnd()
#      drawParticles(self.objects, self.drawSize)
#      drawPoints(self.objects)
          
stars = StarGenerator()
explosion = EffectManager()

def update():
   stars.update()
   explosion.update()


def drawLines(startpos, lines, color, size=1, bouncy=None, bounce=1):
   glLineWidth(2)
   glPushMatrix()
   r, g, b = color
   glColor(r, g, b, .5)
   glTranslate(*startpos)
   s = size*.05
   glScale(s, s, s)
   glNormal(0, 0, 1)
   for line in lines:
      glPushMatrix()
      if line is bouncy:
         glScale(bounce, 0, 0)
      for char in line:
         glutStrokeCharacter(GLUT_STROKE_ROMAN, ord(char))
         glTranslate(size*5, 0, 0)
      glPopMatrix()
      glTranslate(0, -size*250, 0)
   glPopMatrix()
   glLineWidth(1)

def drawWord(pos, string, color, size=1):
   glLineWidth(2)
   r, g, b = color
   glPushMatrix()
   glColor(r, g, b, .5)
   glTranslate(*pos)
   s = size*.05
   glScale(s, s, s)
   glNormal(0, 0, 1)
   for char in string:
      glutStrokeCharacter(GLUT_STROKE_ROMAN, ord(char))
#      glTranslate(size*5, 0, 0)
   glPopMatrix()
   glLineWidth(1)
   





# vim: set et sts=3 sw=3:
