import options
from util import *
from ship import Player
import powerups
import hiscore
import weapon

class Players(list):
   ships = property(lambda self: [ship for ship in self if ship.alive])
   
   def __init__(self):
      if options.difficulty is 'easy':
         self.damageFactor = 0.5
      elif options.difficulty is 'medium':
         self.damageFactor = 0.75
      elif options.difficulty is 'hard':
         self.damageFactor = 1.0
      for i in range(options.players):
         p = Player()
         p.controls = eval("options.Player%sControls" % str(i+1))
         p.name = eval("options.Player%sName" % str(i+1))
         p.damageFactor = self.damageFactor
         self.append(p)
   
   def areAlive(self):
      for p in self:
         if p.alive:
            return True
   
   def getClosest(self, pos):
      return closest(pos, self.ships)
   
   def getCollision(self, ships):
      for p in self:
         p.getCollision(ships)
         if p.alive:
            powerups.getCollision(p)
   
   def update(self):
      for p in self:
         p.update()
   
   def draw(self):
      for p in self:
         if p.alive:
            p.draw()
   
   def areWeaponsUpgradeable(self):
      for p in self.ships:
         if weapon.areWeaponsUpgradeable(p):
            return True
   
   def areShipsUpgradeable(self):
      for p in self.ships:
         if p.modelID < 3:
            return True
   
   def godMode(self):
      for p in self:
         p.godMode = True
   
   def highestScoringPlayer(self):
      return max((player.score, player.name) for player in self)
   
   def die(self):
      for player in self.ships:
         player.die()
   
   def writeScores(self):
      return [hiscore.write(p.score, p.name) for p in self]
   
   def distributePoints(self, score):
      l = len(self)
      for p in self:
         p.score += score/l
         
      
      
players = Players()

# vim: set et sts=3 sw=3:
