# Yoonah's Solarsystem:
#
#write the solar system program
#right now!!!
#are you listening to me?
#you stupid computer!!!
#Write it right now!!!
#Arthur!!
#COme over here and do this!!!
#right now!!!

#from gravityutil import *
from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *

from display import display
import timer
from utilfuncs import *
from vector import *
from color import *

EarthOrbitTime = 6E5
EarthOrbitRadius = 5E4
EarthMass = 2E14
EarthDiameter = 1.2745E3


class Body:
   orientation = 0
   
   def __init__(self, parent, diameter, mass, orbitRadius, orbitPeriod, color):
      self.color = color
      self.startAngle = uniform(-pi, pi)
      if orbitRadius > 5:
         orbitRadius /= 2
      self.orbitRadius = orbitRadius * EarthOrbitRadius
      self.orbitTimer = timer.Timer(orbitPeriod*EarthOrbitTime)
      self.mass = mass*EarthMass
      self.radius = (diameter * EarthDiameter)/2.0
      self.parent = parent
      self.move()
   
   def move(self):
      a = 2*pi*self.orbitTimer.percReady() + self.startAngle
      self.pos = self.parent.pos + Vectorp(self.orbitRadius, a)
   
   def draw(self):
      glPushMatrix()
      glColor(*self.color)
      glTranslate(*self.pos)
      glutSolidSphere(self.radius, 20, 10) 
      glPopMatrix()

class Star(Body):
   def __init__(self, pos, diameter, mass, color):
      self.color = color
      self.pos = pos
      self.mass = mass
      self.radius = (diameter * EarthDiameter)/2.0
   def move(self):
      pass

# Planet stats are from wikipedia's solar system entry
# tweaked somewhat
Sun = Star(Vector(0,0,0), 25, 332950, Color(1,1,.9))
Mercury = Body(Sun, .382, 0.06, .387, .241, Color(1, 0.7 ,0))
Venus = Body(Sun, .949, .82, .72, .615, Color(1,1,0))
Earth = Body(Sun, 1, 1, 1, 1, Color(.1,.1,1))
Mars = Body(Sun, .53, .11, 1.52, 1.88, Color(1, .4, .2))
Jupiter = Body(Sun, 11.2, 318, 5.20, 11.86, Color(.4, .5, .1))
Saturn = Body(Sun, 9.41, 95, 9.54, 29.46, Color(.4, .3, .2))
Uranus = Body(Sun, 3.98, 14.6, 19.22, 84.01, Color(.7, .7, 1))
Neptune = Body(Sun, 3.81, 17.2, 30.06, 164.8, Color(.5, .5, 1))
Pluto = Body(Sun, 0.18, 0.002, 39.5, 248.5, Color(.3, .3, .7))

planets = [Mercury, Venus, Earth, Mars, Jupiter, Saturn, Uranus, Neptune, Pluto]


class Bodies:
   bodies = [Sun] + planets
#   G = 6.67E-11
   G = 1E-10
   
   def apply(self, object):
      object.gravityacc = Vector(0,0,0)
      for body in self.bodies:
         r = dist(object.pos, body.pos)
         acc = self.G * ((body.mass) / r**2)
         object.gravityacc += Vectorp(acc, getAngle(object.pos, body.pos))
   
   def getCollision(self, obj):
      if not obj.alive:
         return
      for body in self.bodies:
         if isCollision(obj, body):
            obj.die()
            return
         
   def draw(self):
      for body in self.bodies:
         if dist(display.cameraLookAt, body.pos)-body.radius < display.screenSize.mag:
            body.draw()
   
   def update(self):
      for body in self.bodies:
         body.move()

bodies = Bodies()

# vim: set et sts=3 sw=3:
