from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *

from vector import *

def isCollision(p, q):
   return (p.radius + q.radius)**2 > (p.pos.x-q.pos.x)**2 + (p.pos.y-q.pos.y)**2

def isCollisionLineSphere(lstart, lend, spherecenter, r):
   x1, y1, z1 = lstart
   x2, y2, z2 = lend
   x3, y3, z3 = spherecenter
   a = (x2 - x1)**2 + (y2 - y1)**2
   b = 2*((x2 - x1)*(x1 - x3) + (y2 - y1)*(y1 - y3))
   c = x3**2 + y3**2 + x1**2 + y1**2 - 2*(x3*x1 + y3*y1) - r**2
   intersects = b**2 - 4*a*c
   if intersects > 0:
      #u1 = (-b**2 + sqrt(intersects)) / (2*a)
      u = (-b - sqrt(intersects)) / (2*a)
      x = u*(x2 - x1) + x1
      y = u*(y2 - y1) + y1
      return Vector(x, y, z3)

def drawLine(start, end, color, alpha=1):
   r,g,b = color
   glColor(r,g,b,alpha)
   glNormal(0,0,1)
   glBegin(GL_LINES)
   glVertex(*start)
   glVertex(*end)
   glEnd()

def avgVel(v, a, dst, target):
   # this is dist = 1/2at^2 + vt solved for t
   try:
      t = (-v + sqrt(v**2 + 2*a*dst)) / a
   except ValueError:
      return v
   avgvel = dst/t
   return avgvel

# vim: set et sts=3 sw=3:
